Bug 507077

Summary: modem-modeswitch not working for a certain class of devices
Product: [Fedora] Fedora Reporter: Bill Gradwohl <bill>
Component: udevAssignee: Harald Hoyer <harald>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: low    
Version: 11CC: dcbw, harald
Target Milestone: ---   
Target Release: ---   
Hardware: x86_64   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2010-06-28 09:10:46 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Attachments:
Description Flags
China Bird modem patch none

Description Bill Gradwohl 2009-06-20 12:06:23 EDT
Description of problem:
For a USB stick modem Vendor=ox1c9e product=0x1001 , the modem-modeswitch routine makes the modem disappear from lsusb. Its as though its not plugged in. This device is known as an Alcatel, GBC, China Bird, etc modem.

Version-Release number of selected component (if applicable):


How reproducible:

Steps to Reproduce:
1.Write a rule similar to the existing rules in /lib/udev/rules.d/61-option-modem-modeswitch.rules

2.Boot the box
3.Insert USB stick
  
Actual results:
Jun 20 09:52:10 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 2
Jun 20 09:52:10 multimedia kernel: usb 4-2: New USB device found, idVendor=1c9e, idProduct=1001
Jun 20 09:52:10 multimedia kernel: usb 4-2: New USB device strings: Mfr=1, Product=2, SerialNumber=3
Jun 20 09:52:10 multimedia kernel: usb 4-2: Product: USB MMC Storage
Jun 20 09:52:10 multimedia kernel: usb 4-2: Manufacturer: USB Modem
Jun 20 09:52:10 multimedia kernel: usb 4-2: SerialNumber: 000000000002
Jun 20 09:52:10 multimedia kernel: usb 4-2: configuration #1 chosen from 1 choice
Jun 20 09:52:11 multimedia kernel: Initializing USB Mass Storage driver...
Jun 20 09:52:11 multimedia kernel: scsi6 : SCSI emulation for USB Mass Storage devices
Jun 20 09:52:11 multimedia kernel: usbcore: registered new interface driver usb-storage
Jun 20 09:52:11 multimedia kernel: USB Mass Storage support registered.
Jun 20 09:52:19 multimedia kernel: usb 4-2: reset full speed USB device using ohci_hcd and address 2
Jun 20 09:52:19 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:20 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:20 multimedia kernel: usb 4-2: reset full speed USB device using ohci_hcd and address 2
Jun 20 09:52:20 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:20 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:20 multimedia kernel: usb 4-2: reset full speed USB device using ohci_hcd and address 2
Jun 20 09:52:21 multimedia kernel: usb 4-2: device not accepting address 2, error -62
Jun 20 09:52:21 multimedia kernel: usb 4-2: reset full speed USB device using ohci_hcd and address 2
Jun 20 09:52:21 multimedia kernel: usb 4-2: device not accepting address 2, error -62
Jun 20 09:52:21 multimedia kernel: usb 4-2: USB disconnect, address 2
Jun 20 09:52:21 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 3
Jun 20 09:52:22 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:22 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:22 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 4
Jun 20 09:52:22 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:22 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:52:23 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 5
Jun 20 09:52:23 multimedia kernel: usb 4-2: device not accepting address 5, error -62
Jun 20 09:52:23 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 6
Jun 20 09:52:24 multimedia kernel: usb 4-2: device not accepting address 6, error -62
Jun 20 09:52:24 multimedia kernel: hub 4-0:1.0: unable to enumerate USB device on port 2


an lsusb normally shows it as:
Bus 005 Device 001: ID 1c9e:1001 
It has no description.

Now however, executing lsusb yields:
root@multimedia ~# lsusb
Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 006 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 005 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 003: ID 05c7:2012 Qtronix Corp. 
Bus 002 Device 002: ID 045e:00cb Microsoft Corp. 
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

Its gone!


With these log entries:
Jun 20 09:54:23 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 7
Jun 20 09:54:23 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:54:23 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:54:24 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 8
Jun 20 09:54:24 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:54:24 multimedia kernel: usb 4-2: device descriptor read/64, error -62
Jun 20 09:54:24 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 9
Jun 20 09:54:25 multimedia kernel: usb 4-2: device not accepting address 9, error -62
Jun 20 09:54:25 multimedia kernel: usb 4-2: new full speed USB device using ohci_hcd and address 10
Jun 20 09:54:25 multimedia kernel: usb 4-2: device not accepting address 10, error -62
Jun 20 09:54:25 multimedia kernel: hub 4-0:1.0: unable to enumerate USB device on port 2




Removing the USB device physically makes no entries in the log.




Expected results:
I hoped (expected) that it would convert the device from a storage device (0x1001) to a modem device (0x6061) so hal could find it.

Additional info:
It appears that /lib/udev/rules.d/61-option-modem-modeswitch.rules is "option" centric. The device I have does not use the option driver; it needs the usbserial driver. 

I can manually execute the utility usb_modeswitch from www.draisberghof.de
 and it will switch the modem properly. Once switched, I have other issues related to hal that cause it not to work via the automated mechanisms terminating with NetworkManager. 

I can make the modem work with wvdial manually. It appears that udev wants to control this mode switching so this is the first step in getting this device and many others like it automated. 

Also, the -t option description in the man page for modem-modeswitch isn't very clear as to what the actual options are and what they are supposed to do. Executing /lib/udev/modem-modeswitch from a command line with obviously bad -t parameters (-t xyz) results in no error message and terminates with a 0 return code.
Comment 1 casaitza 2009-11-20 12:43:15 EST
Created attachment 372557 [details]
China Bird modem patch
Comment 2 Harald Hoyer 2010-03-17 07:38:01 EDT
Comment on attachment 372557 [details]
China Bird modem patch

This is a dos exe!!!!
Comment 3 Bug Zapper 2010-04-27 11:06:46 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Dan Williams 2010-05-04 15:17:12 EDT
modem-modeswitch is deprecated in favor of usb_modeswitch.  usb_modeswitch is the correct solution to the issue here.  If there are devices that aren't supported by usb_modeswitch, we should enhance usb_modeswitch to handle those.
Comment 5 Bill Gradwohl 2010-05-04 15:52:52 EDT
I'm using usb_modeswitch from the site in Germany, and it has a problem reconnecting.

If I logout and turn off the machine with the USB modem attached, the hardware keeps power to the USB device, so the next day the device is still a modem device when the O/S wakes up, and then the device won't be recognized.

I have to disconnect the modem (drop power), reconnect the modem, wait a few seconds and then I can connect.
Comment 6 Bug Zapper 2010-06-28 09:10:46 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.